//---------------------------------------------------------------------------//
/**
*   @file       ase2t3d_pcx.h
*   @author     Dire Stockdale 
*   @author     <a href=http://www.solosnake.com>www.solosnake.com</a>
*   @date       20-Nov-01 22:54:51
*   @version    1.00
*/
//-----------------------------------------------------------------------//
#ifndef ASE2T3D_PCX_H
#define ASE2T3D_PCX_H
#include <afxwin.h>  

struct PCXHeader {
    BYTE    Identifier;     //  0x0A
    BYTE    Version;        //  Version Number
    BYTE    Encoding;       //  Encoding format
    BYTE    BitsPerPixel;   //  Bpp
    WORD    XStart;         //  Left of image, should be zero
    WORD    YStart;         //  Top of Image, should be zero
    WORD    XEnd;           //  Right of Image.
    WORD    YEnd;           //  Bottom of image
    WORD    HorzRes;
    WORD    VertRes;
    BYTE    Palette[48];    //  16 colour EGA palette.
    BYTE    Reserved;
    BYTE    NumBitPlanes;   
    WORD    BytesPerLine;   //  Bytes per scan line
    WORD    PaletteType;
    WORD    HorzScreenSize;
    WORD    VertScreenSize;
    BYTE    Reserved2[54];  // Always zero
};

#endif // ASE2T3D_PCX_H
//-----------------------------------------------------------------------------

